\documentclass[a4paper]{article}

\usepackage[toc,page]{appendix}
\usepackage{enumitem}
\usepackage{circledsteps}
\usepackage{xspace}
\usepackage{amssymb}
\usepackage{tikz}
\usepackage{fancyhdr}
\usepackage[pages=some]{background}
\usepackage[nottoc,numbib]{tocbibind}
\usepackage[skins,breakable]{tcolorbox}
\usepackage{longtable}



\usetikzlibrary{positioning, calc, arrows, decorations.markings}
\newcommand{\inlinepicture}[1]{\par
  \parbox{\textwidth}{\center \vspace{.4cm} #1  \vspace{.7cm} }
}
%\setlength{\arrayrulewidth}{1mm}
\setlength{\tabcolsep}{18pt}
\renewcommand{\arraystretch}{1.5}

%\pagestyle{fancy}
%\fancyhead[l]{}
%\fancyhead[r]{}

\tikzset{
  party/.style={
    rectangle,
    draw=black,
		text width=5.5em,
		minimum height=3em,
		text centered
  }
}

\renewcommand{\familydefault}{\sfdefault}

\newlength{\halfpaperheight}
\setlength{\halfpaperheight}{0.5\paperheight}
\newlength{\halfpaperwidth}
\setlength{\halfpaperwidth}{0.5\paperwidth}

\usetikzlibrary{fadings}

\definecolor{color0}{rgb}{0,0,0}% black
\definecolor{color1}{rgb}{0.22,0.45,0.70}% light blue
\definecolor{color2}{rgb}{0.45,0.45,0.45}% dark grey

\definecolor{bggraphicscolor1}{rgb}{0.6,0.7,0.8}
\definecolor{bggraphicscolor2}{rgb}{0.6,0.7,0.8}

\backgroundsetup{
  pages=some,
  firstpage=true,
  opacity=1,
  scale=1,
  angle=0,
  contents={
    \begin{tikzpicture}[overlay, remember picture]
      \shade[top color = blue!5!black!97!white, bottom color = blue!5!black!70!white, shading angle=55] (-\the\halfpaperwidth, -\the\halfpaperheight) rectangle (\the\halfpaperheight, \the\halfpaperheight);
      \foreach \x in {0,...,7}
        {
          \pgfmathsetmacro\bendstart{2}
          \pgfmathsetmacro\benddist{2}
          \pgfmathsetmacro\xoffset{4}
          \pgfmathsetmacro\ypos{\x* -0.5 - 2}
          \pgfmathsetmacro\xpos{mod(\x, 2) / 2 + \xoffset}
          \pgfmathsetmacro\xbendi{\xoffset + \bendstart + \x * 0.3}
          \pgfmathsetmacro\xbendii{\xoffset + \bendstart + \benddist + \x * 0.3}
          \pgfmathsetmacro\ybendii{\x * -0.5}
          \node[circle, draw=bggraphicscolor2, color=bggraphicscolor1] (c1) at (\xpos,\ypos) {¢};
          \ifnum \x <4
            \draw[draw=bggraphicscolor2] (c1) -- (\xbendi, \ypos) -- (\xbendii, \ybendii) --(\the\halfpaperwidth, \ybendii);
          \fi
          \ifnum \x >3
            \draw[draw=bggraphicscolor2] (c1) -- (\the\halfpaperwidth, \ypos);
          \fi
        }
    \end{tikzpicture}
  }
}

\makeatletter
\renewcommand{\maketitle}{%
\begin{titlepage}
  \BgThispage
  \centering{
    \includegraphics[width=\textwidth]{logo/Asset1-inverted} \\
    \vskip5em
    \color{white}
    \huge \@title\\
    \vfill
    \Large \@author\\
    \vskip2em
    \large \@date
    \vskip1em
    \normalsize \version
    
    
  }
\end{titlepage}
}

\newlength{\leftcolumnwidth}
\setlength{\leftcolumnwidth}{0.25\textwidth}
\newlength{\separatorcolumnwidth}
\setlength{\separatorcolumnwidth}{0.05\textwidth}
\newlength{\beforerightcolumnspace}
\setlength{\beforerightcolumnspace}{0.3\textwidth}
\newlength{\rightcolumnwidth}
\setlength{\rightcolumnwidth}{0.7\textwidth}

\newenvironment{teaseritem}[1]
  {
    \noindent
    \begin{tcolorbox}[
      blanker,
      width=\rightcolumnwidth,enlarge left by=\beforerightcolumnspace,
      before skip=6pt,
      breakable,
      overlay unbroken and first={%
        \node[inner sep=0pt,outer sep=0pt,text width=\leftcolumnwidth,
          align=right,
          below right]
          at ([xshift=-\beforerightcolumnspace]frame.north west)
      { \color{color1}{#1}
      };}]
      \setlength{\parskip}{.5em}
  }
  {
    \end{tcolorbox}
    \par\addvspace{15pt}
  }

\title{Draft protocol specification}
\author{Oscar Leijendekker}

\begin{document}

\maketitle

\subsection*{Abstract}
The Planck Payments protocol is an open standard for federated, web-scale,
real-time actionable micro payments between parties that have no
pre-established basis of trust, without relying on a central authority.

This protocol allows micro payment initiatives to gradually realize the
potential market without requiring explosive growth.

\subsection*{Status of this document}
This document is a draft proposal aimed to invite commentary on the Planck
Payments protocol.
This is a work-in-progress distributed on a confidential basis.
All rights reserved.

\newpage
\tableofcontents
\newpage

\section{Introduction}
Micro payments have been proposed as a solution to various problems again and
again, both in business and academia \cite{motivation-2016-david-brin, motivation-2019-joris-lochy, application-library-1998, application-copyright-1997, application-spam-prevention-2005}.
Many attempts at creating a micro payments    %TODO: citations
system have been made, yet they invariably fail. We have identified two central
issues. First, the market for micro payments does not exist yet and must be
built from the ground up. Each initiative must do this over and over again.
Second, most proposals are technically inadequate, resulting in poor safety and
user experience. These issues are further specified in section \ref{sec:problem}.

This proposals describes a strategy to federate micro payment initiatives with
the following goals:
\begin{itemize}
\item Offer technical aid to micro payments initiatives.
\item Legitimize adhering micro payment initiatives.
\item Leverage interoperability to ensure longevity of micro payments in
general, so that new initiatives do not need to start over entirely.
\item Prevent network-effects from creating a monopoly with a stranglehold
on micro payments.
\item Counter harmful or exploitative proposals that poorly address issues that
can be better resolved with micro payments.
\end{itemize}


\section{Problem}
\label{sec:problem}
\subsection{Missing market}
Clients for micro payments are scarce in the current market. Although there are
many potential applications for micro payments, those products cannot exist so
long as micro payments don't exist. This co-dependence makes their introduction
difficult.

Existing products and services that are often cited as potentially
benefiting from micro payments, may be harmed by them instead. For instance,
while performing market research in the Netherlands, we discovered that
newspapers operating on a subscription basis lose subscribers
if they offer their articles for individual resale, and users are generally not
willing to pay enough for an article to cover its production cost.

We must also consider the importance of platforms, such as YouTube and
Spotify. It is crucial for content creator to be platformed in order to reach a
larger audience. Those platforms have their own monetization schemes,
and benefit from cementing their (quasi-)monopoly through the network effect of
subscriptions. Resorting to individual sale is against the platform's interest.

Many companies have already tried to to make micro payments viable. So far, we
have seen fairly centralized approaches, revolving around one company and/or
cryptocurrency. When these initiatives fail, they leave nothing behind and drag
any businesses who relied on them down with them. This has caused a fair bit of
micro payments fatigue.

In short, despite the potential of the micro payments market, micro payment
initiatives will find themselves with few fruitful opportunities. Setting up
a protocol that lives on beyond a single initiative has the potential of
stabilizing the micro payments industry, and allows new entrants to profit,
rather than suffer, from the failures of past attempts.

In the long term, micro payments create interesting new possibilities.
Beyond the classic examples, distribution of digital content and spam
prevention, there are opportunities in smart grids and renewable energy,
micro-leasing of expensive machines like 3d printers or compute clusters and
sharing of resources such as warehousing.

\subsection{Technical limitations}
\label{subsec:tech-limit}
There is no point creating a micro payments system if it cannot handle a very
large throughput. Low value must be compensated with large volumes, and any
micro payments systems should be designed around this principle. Past proposals
have often focused too strongly on transaction fees, which are a completely
artificial and easily remediable problem.

The data we are used to dealing with, videos, music, advertisements... are
constant types which can be copied without issue. Money is linearly typed and
must be spent, or moved, requiring synchronization and trust between source
and destination.
By limits of vertical scaling \cite{memory-wall-1995-wulf}
and the CAP theorem \cite{cap-2000-brewer, cap-2002-gilbert, cap-2012-brewer}
we know that this simply does not scale.
We must, in essence, solve the double spending problem without blocking.
This excludes the possibilities of real-time micro payments in practical
applications, were accounts are locked to avoid race conditions. Yet, most
proposed uses of micro payments require a payments to become actionable quickly
for a reasonable user experience.

The traditional approach of billing payers for overspending is not workable
either. It is not safe under automation and not legal in the EU without strong
authentication \cite{law-EU-2018/389}, but the latter would result in poor user
experience. Nobody wants to use 2-factor authentication for every single
sub-cent payment. We must use strict spending limits and very limited user input
to avoid the user experience problems described in \cite{against-micropayments-1999-szabo} and \cite{against-micropayments-2003-odlyzko}.

One approach deals with this issue well from a technical perspective: the
reverse lottery model \cite{initiative-1997-lottery}. But it is not
user-friendly and may infringe on gambling regulations.

A hybrid approach between real-time and classic payments is required. Where
heuristics prevent double spending, making a payment actionable in real-time,
but actual payment is asynchronous.



\section{Method overview}

The Planck Payments protocol accepts that fast, large-scale processing of micro
payments is invariably subject to errors, and establishes a framework of
measured trust in order to allow processors to employ slightly inaccurate
predictors without financially endangering involved parties. This same framework
of trust also allows multiple parties to offer micro payments under the same
interface.

As in most past proposals, micro payments are paid from a digital wallet; an
account with a strictly positive balance. They are
aggregated into larger deposits before making transfers over existing payment
networks.

Unlike real-time payments, which can only be requested,
completed or rejected, Planck Payments have states Requested, Accepted,
Succeeded/Replicated and Completed, with failure states Rejected, Data Loss and
User Error.


\tikzset{
  state/.style={
    rectangle,
    rounded corners,
    solid,
    draw=black,
		minimum height=3em,
    text width=5.5em,
		text centered,
  },
  errorstate/.style={
    rectangle,
    solid,
    draw=black,
    minimum height=3em,
    text width=5.5em,
    text centered,
  }
}
\tikzstyle{vecArrow} = [thick, decoration={markings,mark=at position
   1 with {\arrow[semithick]{open triangle 60}}},
   double distance=1.4pt, shorten >= 5.5pt,
   preaction = {decorate},
   postaction = {draw,line width=1.4pt, white,shorten >= 4.5pt}]
\tikzstyle{innerWhite} = [semithick, white,line width=1.4pt, shorten >= 4.5pt]

\inlinepicture{
\begin{tikzpicture}
  \node[state] (requested) {Requested};
  \node[state] (accepted) [right = of requested]{Accepted};
  \node[state] (replicated) [right = of accepted]{Replicated};
  \node[state] (completed) [right = of replicated]{Completed};

  \node[errorstate] (errBalance) at ($(requested)!0.45!(accepted)+(0,-1.4)$) {Rejected};
  \node[errorstate] (errNoRepl) at ($(accepted)!0.45!(replicated)+(0,-1.4)$) {Data loss};
  \node[errorstate] (errNoRecipient) at ($(replicated)!0.45!(completed)+(0,-1.4)$) {User error};



  \draw[vecArrow] (requested) -- (accepted);
  \draw[vecArrow] (requested) -| (errBalance);
  \draw[vecArrow] (accepted) -- (replicated);
  \draw[vecArrow] (accepted) -| (errNoRepl);
  \draw[vecArrow] (replicated) -- (completed);
  \draw[vecArrow] (replicated) -| (errNoRecipient);

  \draw[innerWhite] (requested) -- (accepted);
  \draw[innerWhite] (requested) -| (errBalance);
  \draw[innerWhite] (accepted) -- (replicated);
  \draw[innerWhite] (accepted) -| (errNoRepl);
  \draw[innerWhite] (replicated) -- (completed);
  \draw[innerWhite] (replicated) -| (errNoRecipient);
\end{tikzpicture}
}

At POS\footnote{Point Of Sale}, the vendor only waits for a payment to reach
accepted status, and is responsible for ensuring there are no user errors in the
payment request. The payment processor is responsible for minimizing data loss
using heuristics of its own choosing.
Heuristics that currently exist include: user background checks, rate limiting,
outlier detection and our proprietary architecture design that prevents double
spending attacks entirely, turning the issue into one of server quality.
New entrants with a low throughput may also be able to use traditional blocking
strategies.

Crucially, any approach can and is allowed to fail sometimes. Since each payment
by itself is of low value, this is acceptable so long as such occurrences are
rare. Digital signatures are used to monitor processors' accuracy.

\section{Terminology}


\subsection{Parties}
\newcommand{\partyfrom}{Payer\xspace}
\newcommand{\partyto}{Payee\xspace}
\newcommand{\partybankfrom}[0]{Issuing Bank\xspace}
\newcommand{\partywalletfrom}{Issuing Wallet\xspace}
\newcommand{\partybankwalletfrom}{Issuer\xspace}
\newcommand{\partyinitiator}{Payment Agent\xspace}
\newcommand{\partybankto}{Acquirer\xspace}
\newcommand{\partynetwork}{Payment Network\xspace}
\newcommand{\partysuperviser}{Supervisor\xspace}
\newcommand{\partybutton}{Button Provider\xspace}

\begin{tabular}{|p{.23\textwidth}|p{.6\textwidth}|}
  \hline
  \partyfrom & The sender of micro payments. \\ \hline
  \partyto & The recipient of micro payments. \\ \hline
  \partyinitiator & An agent starting payments on \partyfrom's behalf. It can be a browser implementing a ``pay'' button, a smart contract, IoT device etc. \\ \hline
  \partybankfrom & Provides an account used by Payer to make classic payments. Does not strictly have to be a bank. \\ \hline
  \partywalletfrom & Entity managing \partyfrom's balance for the sake of making micro payments. \\\hline
  \partybankwalletfrom & Entity that is both \emph{\partybankfrom} and \emph{\partywalletfrom}. \\\hline
  \partybankto & The entity receiving payments on behest of \partyto, such as \partyto's bank \\\hline
  \partynetwork & The network over which funds are transfered from \partywalletfrom to \partybankto \\\hline
  \partysuperviser & A party tasked with ensuring fairness to \partyto{}s \\\hline
  \partybutton & The party that provides a safe widget to embed into websites to effectuate payments in the Planck Payments model. \\\hline
\end{tabular}


\section{Payment flow}
This section describes how funds are transferred and authorization is handled
throughout the payment process.

\subsection{Authorize payments}
\label{flow:authorization}
Before performing any micro payments, it is necessary for \partyfrom's safety (and required by law) to authorize future payments up to a certain sum total. If the operation is used to create a new wallet, rather than refill an existing one, a public key must also be transferred from Payer to Wallet Provider in the same operation. This public key will be used to authorize micro payments.

Funds are transferred from \partybankfrom to \partywalletfrom with a method
provided by \partywalletfrom.

\inlinepicture{
  \begin{tikzpicture}
    \node[party] (payer) {\partyfrom};
    \node[party] (bank) [below left = 1.3cm and .5cm of payer] {\partybankfrom};
    \node[party] (wallet) [below right = 1.3cm and .5cm of payer] {\partywalletfrom};
    \draw[->] (payer)-- node[above left]{\Circled{1}} (bank);
    \draw[->] (bank)-- node[above]{\Circled{2}} (wallet);
    \draw[->] (payer)-- node[above right]{\Circled{3}} (wallet);
  \end{tikzpicture}
  \begin{description}
  \item [\Circled{1}] Authorization using strong authentication.
  \item [\Circled{2}] Transfer of authorized sum.
  \item [\Circled{3}] (Conditional) Send \partyfrom's public key.
  \end{description}
}

Since this is the only step using strong authentication, \partywalletfrom may
never bill \partyfrom for any costs beyond what is transferred in this step.
This is both a matter of law and user experience.

If there is an \partybankwalletfrom acting as both \partybankfrom and
\partywalletfrom, authentication is mostly a database update
\inlinepicture{
  \begin{tikzpicture}
    \node[party] (payer) {\partyfrom};
    \node[party] (issuer) [right = 2cm of payer] {\partybankwalletfrom};
    \draw[->] (payer)-- node[above]{\Circled{1} \Circled{2}} (issuer);
  \end{tikzpicture}
  \begin{description}
  \item [\Circled{1}] Authorization using strong authentication.
  \item [\Circled{2}] (Conditional) Send public key.
  \end{description}
}

\subsection{Payment Acceptance}
\label{flow:acceptance}
Payments are initiated by a \partyinitiator on behalf of \partyfrom. The
\partyinitiator can be many things, ranging from a button on a website
that \partyfrom pressed, to a washing machine buying energy from a smart
grid when prices are low. \partyinitiator initiates a payment by sending a
payment request to \partywalletfrom signed with \partyfrom's private key, of
which the matching
public key was sent to \partywalletfrom in \ref{flow:authorization}.

The \partyinitiator accepts or rejects the request. For accepted requests a
signed receipt is sent back to \partyinitiator, who can forward it to \partyto
as proof of purchase.

\inlinepicture{
  \begin{tikzpicture}
    \node[party] (initiator) {\partyinitiator};
    \node[party] (wallet) [below = 1.5 cm of initiator] {\partywalletfrom};
    \node[party] (recipient) [right = 1cm of initiator]{\partyto};
    \draw[->] ([xshift=-0.1cm]initiator.south) -- node[left]{\Circled{1}} ([xshift=-0.1cm]wallet.north);
    \draw[->] ([xshift=0.1cm]wallet.north) -- node[right] {\Circled{2}} ([xshift=0.1cm]initiator.south);
    \draw[->] (initiator) -- node[above]{\Circled{3}} (recipient);
  \end{tikzpicture}

  \begin{description}
  \item [\Circled{1}] Payment request. See \ref{datatypes:payment-request}.
  \item [\Circled{2}] (On acceptance) Receipt. See \ref{datatypes:receipt}.
  \item [\Circled{3}] (On acceptance) Receipt from \Circled{2} forwarded to \partyto as proof of purchase.
  \end{description}
}

Accepted requests can not be canceled. Rejected requests may never be initiated.


\subsection{Payment Propagation}

After a \partywalletfrom has accepted a payment, it waits until the payment has
replicated to ensure it can no longer fail due to data loss. Payments are then
aggregated and sent over a traditional payment network.

\partywalletfrom is required to send along a digitally signed list of payments
made to \partyto, which must match the transferred sum, so that \partyto may
later verify how many of the payments that were accepted by \partywalletfrom have
actually come through.

\inlinepicture{
  \begin{tikzpicture}
    \node[party] (wallet) {\partywalletfrom};
    \node[party] (network) [right = of wallet] {\partynetwork};
    \node[party] (acquirer) [right = of network] {\partybankto};
    \node[party] (recipient) [below = of acquirer] {\partyto};
    \draw[->] (wallet) -- node[above]{\Circled{1}} (network);
    \draw[->] (network) -- node[above]{\Circled{1}} (acquirer);
    \draw[<->] (acquirer) -- node[right]{\Circled{2}} (recipient);
  \end{tikzpicture}

  \begin{description}
  \item [\Circled{1}] Clearance and Settlement.
  \item [\Circled{2}] Deposits and Withdrawals.
  \end{description}
}



\subsection{Oversight}
\label{sec:oversight}
With the list of payments and a random sample of receipts, \partyto can verify
\partywalletfrom's trustworthiness by simply checking how many accepted payments
have not been delivered. This should be close to 0\%.
To facilitate this process, promote fairness, price transparency and equal
access to market, a third-party \partysuperviser{}s can collect receipts and
lists of payments from multiple \partyto{}s to more publicly establish the
trustworthiness of \partywalletfrom{}s.

\inlinepicture{
  \begin{tikzpicture}
    \node[party] (recipientA) {\partyto 1 };
    \node (dots) [below = .4 cm of recipientA]{\vdots};
    \node[party] (recipientB) [below = .5 cm of dots] {\partyto N};
    \node[party] (superviser) [right = 2cm of recipientA]{\partysuperviser};

    \draw[->] ([yshift=0.1cm]recipientA.east) -- node[above]{\Circled{1}} ([yshift=0.1cm]superviser.west);
    \draw[->] ([yshift=-0.1cm]superviser.west) -- node[below]{\Circled{2}} ([yshift=-0.1cm]recipientA.east);
    \draw[->] ([yshift=0.1cm]recipientB.east) node[above, xshift=1cm]{\Circled{1}} -| ([xshift=-0.1cm]superviser.south);
    \draw[<-] ([yshift=-0.1cm]recipientB.east) node[below, xshift=1cm]{\Circled{2}} -| ([xshift=0.1cm]superviser.south);
  \end{tikzpicture}

  \begin{description}
  \item [\Circled{1}] List of receipts and received payments per \partywalletfrom{}.
  \item [\Circled{2}] Probability of accepted payment turning into completed payments per \partywalletfrom{}.
  \end{description}
}

\partysuperviser{}s should take special care to ensure data neutrality.
An \partywalletfrom could artificially boost its score by sending
payments to itself without risk of double spending, and adversarial \partyto{}s
could selectively share receipts only for payments that have been lost.

\subsection{Complete diagram}
We present the complete system diagram below, where double arrows denote streams of money and control over such streams. Regular arrows denote other data streams.

\inlinepicture{
  \begin{tikzpicture}
    \node[party] (payer) {\partyfrom};
    \node[party] (initiator) [right = of payer] {\partyinitiator};
    \node[party] (bankfrom) [below = of payer]{\partybankfrom};
    \node[party] (wallet) [below = of initiator]{\partywalletfrom};
    \node[party] (network) [right = of wallet]{\partynetwork};
    \node[party] (bankto) [right = of network]{\partybankto};
    \node[party] (payee) [above = of bankto]{\partyto};
    \node[party] (superviser) [above = of payee]{\partysuperviser};

    \draw[->, double] (payer) -- node[left]{\Circled{1}} (bankfrom);
    \draw[->, double] (bankfrom) -- (wallet);
    \draw[->] (payer) -- (wallet);
    \draw[->] (payer) -- node[above]{\Circled{2}} (initiator);
    \draw[->, double] (initiator) -- node[right]{\Circled{3}} (wallet);
    \draw[->, double] (wallet) -- (network);
    \draw[->, double] (network) -- (bankto);
    \draw[<->, double] (bankto) -- (payee);
    \draw[<->] (payee) -- node[right]{\Circled{5}} (superviser);
    \draw[<->] (initiator) -- node[above]{\Circled{4}} (payee);
  \end{tikzpicture}

  \begin{description}
  \item [\Circled{1}] Authorization;
  \item [\Circled{2}] Global input to \partyinitiator. E.g. button clicks or programming an autonomous agent.
  \item [\Circled{3}] Micro payment request;
  \item [\Circled{4}] Exchange of goods and services for signed receipts.
  \item [\Circled{5}] Oversight strategy.
  \end{description}
}

\section{Data objects}

Each of the following data objects is a JWT (RFC 7519) encoded as a
JWS structure (RFC 7515).
It must be signed using RS256, RS384 or RS512 algorithms (RFC 7518).
% --- addition by Securify
In order to ensure that semantically equivalent objects are symbolically equal,
the JSONs and unencoded JWTs may not contain whitespaces, fields may not be
repeated, the order of fields must be respected, and no fields beyond the ones
listed may be added.
% --- end addition by Securify


\subsection{Payment request}
\label{datatypes:payment-request}

A payment request is signed by \partyfrom and contains the following claims:

\vspace{.5cm}
\begin{tabular}{|c|p{.8\textwidth}|}
\hline
wallet id     & The UUID identifying the sender's wallet \\\hline
recipient id  & Unique identifier denoting the recipient. Exact definition TBD, see \ref{issue:network}. Can be bank account number or UUID. \\\hline
value         & Sum to be transferred. Exact definition TBD, for instance $i \in \mathbb{N}$ denoting $\frac{1}{100}$ eurocent. See \ref{issue:minimum} and \ref{issue:currency}. \\\hline
product id    & A UUID denoting a product. Used to cache receipts. \\\hline
---           & TBD, see \ref{issue:dependent-pricing}. \\\hline
---           & TBD, see \ref{issue:payment-request-uniqueness}. \\\hline
metadata      & Additional data to be stored. Byte string intended as a free field for \partyto to store further specification not covered by base fields. May be an empty string. Size limits TBD. \\\hline
\end{tabular}
\vspace{.5cm}


\subsection{Receipt}
\label{datatypes:receipt}

A receipt is signed by \partywalletfrom and contains the following claims:

\vspace{.5cm}

\begin{tabular}{|c|p{.8\textwidth}|}
  \hline
  payment id      & A UUID identifying the payment, generated by \partywalletfrom. \\\hline
  recipient id    & Copied from payment request. \\\hline
  value           & Copied from payment request. \\\hline
  product id      & Copied from payment request. \\\hline
  timestamp       & A timestamp denoting when the receipt was signed. \\\hline
  ---             & TBD. See \ref{issue:dependent-pricing}. \\\hline
  ---             & TBD. See \ref{issue:payment-list-preindexing}. \\\hline
  metadata        & Copied from payment request. \\\hline
\end{tabular}
\vspace{.5cm}

As evident from the above, no personally identifiable information of \partyfrom is present in a Receipt.


\subsection{Payment rejection}
\label{datatypes:rejection}
A payment rejection is signed by \partywalletfrom and contains the same fields
as a payment request, followed by:

\begin{tabular}{|c|p{.8\textwidth}|}
  \hline
  rejection reason  & A JSON string denoting the reason for the rejection. Valid values are [``Unauthorized'', ``LowBalance'', ``RateLimit'', ``RequestError'', ``InternalError''] (more values TBD). \\\hline
\end{tabular}

\subsection{Payments list}
\label{data:payments-list}

A Payment list, sent to \partyto with the transfered sum, is signed by
\partywalletfrom and contains the following fields:

\begin{tabular}{|c|p{.8\textwidth}|}
  \hline
  payments        & A list of Payment Entries \\\hline
\end{tabular}
\vspace{.5cm}

A payment entry is a JSON with the following fields:
\vspace{.5cm}

\begin{tabular}{|c|p{.8\textwidth}|}
  \hline
  payment id      & ID of matching receipt. \\\hline
  value           & Sum of the payment, must match receipt. \\\hline
\end{tabular}
\vspace{.5cm}


\section{API Endpoints}
A \partywalletfrom adhering to the Planck Payments protocol must implement the
following endpoints over HTTPS:

\subsection*{\texttt{/pay}}
\begin{teaseritem}{Description}
This endpoint is called to start a payment and obtain a receipt. The server may
accept or reject the request.
\end{teaseritem}
\begin{teaseritem}{Method}
POST
\end{teaseritem}
\begin{teaseritem}{Parameters}
---
\end{teaseritem}
\begin{teaseritem}{Body}
A payment request as specified in \ref{datatypes:payment-request}
\end{teaseritem}
\begin{teaseritem}{Responses}

\begin{longtable}{p{.2\textwidth}|p{0.07\textwidth}|p{0.3\textwidth}} \hline
\textbf{condition} & \textbf{status} & \textbf{body} \\\hline
Payment accepted & 202 & A receipt as specified in \ref{datatypes:receipt} \\\hline
Payment request was invalid & 400 & --- (no signed rejection is necessary if the request was not valid).\\\hline
Payment rejected due to low balance & 402 & A payment rejection with reason ``LowBalance'' as specified in \ref{datatypes:rejection}.\\\hline
Bad signature on payment request & 403 & A payment rejection with reason ``Unauthorized'' as specified in \ref{datatypes:rejection}.\\\hline
Payment rejected due to rate limit & 429 & A payment rejection with reason ``RateLimit'' as specified in \ref{datatypes:rejection}.\\\hline
User error with valid payment request & 4xx & A payment rejection with reason ``RequestError'' as specified in \ref{datatypes:rejection}.\\\hline
Server error & 5xx & A payment rejection with reason ``InternalError'' as specified in \ref{datatypes:rejection}.
\end{longtable}

\end{teaseritem}




\section{Frontend}
\label{sec:frontend}
Micro payments are often proposed for use in website, but this raises a few
tricky issues. To minimize user interaction, payments should be truly
single-click, which forbids navigating to the domain of a \partywalletfrom. Yet
we cannot allow third-party code to access \partyfrom's private key or send
valid requests to \partywalletfrom's API by its own volition, or any website
would be able to employ Cross-Origin Request Forgery to steal the contents of
a visitor's wallet.

Ultimately, the best solution is to create a new native HTML element to act as
payment button, but this requires cooperation from all major browsers and the
W3C, which is unlikely in early stages.
The W3C has attempted a frontend specification with very similar goals as the
ones described in this document as early as 1999 \cite{w3c-micropayments}, but
those efforts appear to have been discontinued.

Lacking a safe html element, a central party is required to host a button from
a trusted domain, to be used in an iframe.


\inlinepicture{
  \begin{tikzpicture}
    \node[party] (website) {\partyto{}'s website};
    \node[party] (frontend provider) [above = 2cm of website] {\partybutton};
    \node[party] (button) [right = 2cm of website] {Button};
    \draw ([xshift=-.1cm,yshift=.5cm]website.north west) rectangle ([xshift=.1cm,yshift=-.1cm]button.south east);
    \node[anchor=south] (browser) at ($(website.north)!0.5!(button.north)$) {Browser};
    \node[party] (user) [below = 1cm of button]{\partyfrom};
    \node[party] (wallet) [above = 2 cm of button]{\partywalletfrom};
    \draw[->] (website) -- node[above left]{\Circled{1}} (frontend provider);
    \draw[->] (frontend provider) -- (button);
    \draw[->] (user) -- node[left]{\Circled{2}}(button);
    \draw[->] ([xshift=-0.05cm]button.north) -- ([xshift=-0.05cm]wallet.south);
    \draw[<-] ([xshift=0.05cm]button.north) -- node[right]{\Circled{3}} ([xshift=0.05cm]wallet.south);
    \draw[->] (button) -- node[below]{\Circled{3}} (website);

  \end{tikzpicture}

  \begin{description}
  \item [\Circled{1}] Request button widget
  \item [\Circled{2}] Click
  \item [\Circled{3}] Acceptance as specified in section \ref{flow:acceptance}
  \end{description}
}

While this would ensure payments on websites can only be initiated
by clicking on the iframe-enclosed button, it leaves the issue of clickjacking.
This is a broader problem of the HTML specification that also effects e.g.
social media like buttons. It can initially be solved using whitelists of
trusted websites, managed by the party hosting the button, but should eventually
be addressed by the W3C and browsers.


\section{Open problems and considerations}

\subsection{Protocol update strategy}
It is unlikely that every decision will be correct when the Planck Payments
protocol is first used. Micro payments are still extremely niche, making it
impossible to give definite answers on many practical questions, such as the
ones posted below.

A strategy should be specified to publish new versions of the protocol and
encourage adhering \partywalletfrom{}s to update their servers.


\subsection{Fees}
\label{issue:fees}
Fees can be levied by \partywalletfrom when transferring aggregated payment
funds to \partyto. While it seems a safe assumption that fees should be a flat
rate with micro payments, we have not determined what the rate should be.

We've heard claims that a 5\% fee is unacceptably high but also that 10\% does
not cover costs for new entrants considering the current market share. A
long term plan of decreasing fees seems in order.


\subsection{Minimal payment and increment size}
\label{issue:minimum}
We have not yet specified the smallest sum nor the smallest increment for
micro payments. Some further look at use-cases is required and it is quite
likely this will have to be redefined in the future as new use-cases (fail to)
emerge.

\subsection{Currency}
\label{issue:currency}
We have not yet specified what currency to use, nor if and how currency
conversion should take place. For initial use, EUR or USD should be sufficient.
Nevertheless, currency should probably be specified in data objects for
future-proofing.

\subsection{Network choice and multi-network support}
\label{issue:network}
We have not specified which payment network to use for aggregated payment
settlement. In principle it is possible to allow multiple networks, by letting
the recipient id denote accounts on multiple networks and letting the
\partywalletfrom choose one to use. This would reduce interoperability when not
all \partyto{}s and \partywalletfrom{}s support the same networks.

\subsection{Sub-cent part of sum}
We have not yet determined how to handle that part of the sum in aggregated
payments that is smaller than the smallest increment supported by a
network. E.g. how to send a sum of 5.007 EUR, when the smallest value for EUR is
0.01 EUR. An obvious solution is to round sums down, but too many aspects of the
proposal are still in flux to determine whether that is acceptable.

\subsection{Purchase cache}
\label{issue:product-id-cache}
In some cases it would be beneficial to ensure a product can be purchased only
once. For instance, a service might sell songs and might not want clients to be
able to buy a song multiple times. To facilitate this, \partywalletfrom could
store a product ID and retrieve the receipt for said product ID if it was
already purchased. This would greatly simplify the system required by \partyto,
who could operate by only checking signatures, no longer requiring any client
database. It would also prevent errors from making a client buy the same product
twice by accident. On the other hand, it would also add a database lookup to
payments and require more storage capacity from \partywalletfrom.


\subsection{Custom \partywalletfrom{} buttons}
\ref{sec:frontend} details the creation of payment buttons. It is possible to
allow each \partywalletfrom to use their own button design, within a certain
design space. We are unsure on whether this is better than having a single
Planck Payments button design.


\subsection{New entrants without trust score}
\label{issue:new-entrants}
We have not yet determined how to handle new \partywalletfrom{}s who do not yet
have a transaction history to determine their credibility. Trusted 3rd parties
are an option as they are used in traditional payment methods, but relying on
them would undermine the non-centralized approach of the rest of the protocol.

\subsection{Publication of \partywalletfrom{}s' public keys}
\label{issue:pubkeys}
Related to \ref{issue:new-entrants}, we have not yet determined how
\partywalletfrom{}s should distribute their public keys.

\subsection{Leaked \partywalletfrom{}s' private keys}
Related to \ref{issue:new-entrants} and \ref{issue:pubkeys}, we have not
determined how to handle cases in which a \partywalletfrom accidentally leaked
a private key. In the current situation, \partywalletfrom's trust score would be
zeroed, which may or may not be desirable.



\subsection{\partyfrom{}'s billing insight}
\label{appendix:oversight-for-payer}
Non-micro payments rely on \partyfrom{}s to verify that the payment history
is correct. With micro payments, that becomes too large a burden to place upon
\partyfrom. Even storing the payment history locally is not ideal as accidental
data loss and the use of multiple devices can create gaps in the local history.

The problem can be solved in the Planck Payments model because all payment
requests and rejections must be signed.
In general, we can require \partywalletfrom to justify every payment on the bill
to \partyfrom with a signed payment request, and \partyfrom would optionally
collect signed rejections, the payment requests of which should not appear on
the bill. This process is fairly simple to automate.
This does come with some with some
important considerations listed below.



% ------
\subsubsection{Payment request uniqueness}
\label{issue:payment-request-uniqueness}
For the above to work, each payment request must only be allowed to appear on
the bill once, meaning each payment request must be unique.

We have envisioned 3 ways of achieving this:
\begin{enumerate}
\item \label{solution:timestamp} Add a timestamp to payment requests.
\item \label{solution:uuid} Add a UUID v4 created by \partywalletfrom, to payment requests.
\item \label{solution:product-id} Drop payments with the same product id.
\end{enumerate}

Solution \ref{solution:timestamp} requires \partywalletfrom to cache recent
payment requests to verify the uniqueness of a payment request, rejecting any
payments requests with timestamps that are older than a certain time period or
that have duplicated stored within that time period. This requires an additional
database access in the time-critical payment acceptance phase.

Solution \ref{solution:uuid} requires communication between \partywalletfrom and
\partyfrom before making the payment, complicating the API with state and
requiring sessions to ensure \partyfrom{}s connect to the same API server node
that generated the UUID.

Solution \ref{solution:product-id} relies on product ids
(see \ref{issue:product-id-cache}) for
uniqueness, allowing \partywalletfrom{}s to drop payments with the same product
id \emph{after} acceptance, returning funds to the wallet without reporting them
on the eventual bill. This would send receipts to \partyto{}s that will never
result in payments. We are unaware of any method to establish trust scores under
this condition that does not rely on sharing an identifier unique to \partyfrom
with \partyto, which would break \partyfrom's anonymity.

More solutions may exist to this problem.


\subsubsection{Multiple, revocable \partyfrom keys}
It is common to allow users to create and revoke keys, for instance in case the
keys are compromised. Doing so in the Planck Payments protocol would make
\partywalletfrom responsible for identifying \partyfrom and managing \partyfrom's
keys in a method that cannot be verified automatically.

It seems prudent to disallow multiple keys and key revocation until this issue
has been adequately addressed.


\subsection{\partywalletfrom-dependent pricing}
\label{issue:dependent-pricing}
Since \partywalletfrom{}s may have different success rates in their heuristics,
\partyto{}s have different expected returns from different \partywalletfrom{}s,
and they may wish to adjust their prices accordingly.

\partyto may receive the probability $P(c_p^w|a_p^w)$ (the change that a payment
will be credited, given that it was accepted by \partywalletfrom $w$) from a
\partysuperviser. This can then be used to determined the purchase price:

$$v^{w} = \frac{v}{P(c_p^w|a_p^w)}$$

Where $v^{w}$ is the price for users of \partywalletfrom $w$, and $v$ is the
base price that \partyto wishes to charge.

The protocol could be expanded to include signed $P(c_p^w|a_p^w)$ values (with
timestamps) in payment receipts, to allow \partyto{}s to verify $v^{w}$
without resorting to time-varying state.

We are unsure how valuable this addition to the protocol would be, or how
desirable variable pricing might be.


\subsection{Payment list id in receipt}
\label{issue:payment-list-preindexing}
The protocol currently relies on payments eventually being credited to \partyto,
but does not specify an exact time-frame. This makes it a bit more difficult to
compare receipts and lists of credited payments.

Receipts should include an identifier specifying when and in which list a
payment will be credited if it is credited.

Adding this specification requires making decisions about sensible time-frames
for payment delivery, which is dependent on \ref{issue:network} and business
insight.

\subsection{Protection against ``embrace, expand, extinguish''}
Measures should be takes to protect the protocol against ``embrace, expand,
extinguish'' strategies, where a standard is first embraced by a party, who then
makes additions to it that are unavailable to other parties. This is a legal
issue before it is a technical one.

\subsection{Choice of \partybankto{}s}
Although the protocol allows transfers to any \partybankto connected to the
supported \partynetwork, it may make more business sense to make this role
exclusive to parties that also act as \partywalletfrom. Currently, micro payment
processors recruit \partyto{}s into their own solution. Allowing any existing
\partybankto would punish \partywalletfrom for joining the Planck Payments
protocol by rendering their services obsolete for \partyto{}s.


\subsection{Using ``stake''}
Certain cryptocurrencies have started using ``stake'' in their payment
processing. The core idea behind it is that long-time users have a high interest
in ensuring continued correct operation of the system.

The Planck Payments system has an even more real, though also more difficult to
calculate, concept of stake. A \partywalletfrom has a stake in maintaining
trustworthiness towards a \partyto -- or group of \partyto{}s using the same
\partysuperviser -- directly related to the transaction fees it levies from
payments to said \partyto.


\section{Future protocol expansions}

\subsection{Smart contracts}
There is no technical reason not to run smart contracts from a wallet. The
simplest smart contract would be a subscription.
While this feature is interesting and has a lot of potential, we believe it to
be too complex and beyond the initial scope of the protocol to be included at
launch.

\subsection{Offline payment guarantees}
For some micro payment applications it may be undesirable to involve a
\partywalletfrom at POS. For instance in situations where an internet connection
is (temporarily) unavailable or where tight timing restrictions make it
unreasonable to wait on the server of a \partywalletfrom with an unknown
latency. As an example of the latter case we propose toll points along highways
where toll is paid automatically through an app while driving at over 100km/h,
so that there may only be a short interval of time before the connection with
the toll point is lost.

Without being able to predict upcoming payments, this situation makes it
completely impossible to prevent double spending, as the (semi-)centralized
party that could prevent it is removed from the equation. This makes it a very
different problem from what we have been trying to solve. So while solutions,
with drawbacks, exist for some such cases and could be integrated into the
Planck Payments API spec, we do not believe it to be a good launching feature
as it would be an entirely new way of processing payments existing in parallel
with the one proposed.


\bibliography{spec}
\bibliographystyle{ieeetr}


\begin{appendices}


\end{appendices}
\end{document}
